/*
 File: LR1_sp4sym.cpp
 Date and Time: Mon Oct 13 18:18:13 2014 
*/
#include "LR1_sp4.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_LR1_sp4;// grammar's ns
// first set terminals
// monolithic grammar --- no thread
void 
Clr1_sp4_fsm::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Rlr1_sp4_:{
       Rlr1_sp4* sym;
     if(re->rule_ == 0){
       sym = new Rlr1_sp4(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlr1_sp4*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_RS_:{
       RS* sym;
     if(re->rule_ == 0){
       sym = new RS(parser__);
       re->rule_ = sym;
     }else{
       sym = (RS*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs2_RS_:{
       RS* sym;
     if(re->rule_ == 0){
       sym = new RS(parser__);
       re->rule_ = sym;
     }else{
       sym = (RS*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs3_RS_:{
       RS* sym;
     if(re->rule_ == 0){
       sym = new RS(parser__);
       re->rule_ = sym;
     }else{
       sym = (RS*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs4_RS_:{
       RS* sym;
     if(re->rule_ == 0){
       sym = new RS(parser__);
       re->rule_ = sym;
     }else{
       sym = (RS*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs1_RA_:{
       RA* sym;
     if(re->rule_ == 0){
       sym = new RA(parser__);
       re->rule_ = sym;
     }else{
       sym = (RA*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_RB_:{
       RB* sym;
     if(re->rule_ == 0){
       sym = new RB(parser__);
       re->rule_ = sym;
     }else{
       sym = (RB*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    default: return;
   }
}
